pcl::gpu::EuclideanLabeledClusterExtraction< PointT > Class Template Reference
Module segmentation

EuclideanLabeledClusterExtraction represents a segmentation class for cluster extraction in an Euclidean sense, depending on pcl::gpu::octree More...

`#include </build/pcl-OilVEB/pcl-1.8.1+dfsg1/gpu/segmentation/include/pcl/gpu/segmentation/gpu_extract_labeled_clusters.h>`

## Public Types

typedef pcl::PointXYZ | PointType
typedef pcl::PointCloud< PointT > | PointCloudHost
typedef PointCloudHost::Ptr | PointCloudHostPtr
typedef PointCloudHost::ConstPtr | PointCloudHostConstPtr
typedef PointIndices::Ptr | PointIndicesPtr
typedef PointIndices::ConstPtr | PointIndicesConstPtr
typedef pcl::gpu::Octree | GPUTree
typedef pcl::gpu::Octree::Ptr | GPUTreePtr
typedef pcl::gpu::Octree::PointCloud | CloudDevice

## Public Member Functions

| EuclideanLabeledClusterExtraction ()
| Empty constructor. More...
void | setSearchMethod (const GPUTreePtr &tree)
| Provide a pointer to the search object. More...
GPUTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
void | setClusterTolerance (double tolerance)
| Set the spatial cluster tolerance as a measure in the L2 Euclidean space. More...
double | getClusterTolerance ()
| Get the spatial cluster tolerance as a measure in the L2 Euclidean space. More...
void | setMinClusterSize (int min_cluster_size)
| Set the minimum number of points that a cluster needs to contain in order to be considered valid. More...
int | getMinClusterSize ()
| Get the minimum number of points that a cluster needs to contain in order to be considered valid. More...
void | setMaxClusterSize (int max_cluster_size)
| Set the maximum number of points that a cluster needs to contain in order to be considered valid. More...
int | getMaxClusterSize ()
| Get the maximum number of points that a cluster needs to contain in order to be considered valid. More...
void | setInput (CloudDevice input)
void | setHostCloud (PointCloudHostPtr host_cloud)
void | extract (std::vector< PointIndices > &clusters)
| Cluster extraction in a PointCloud given by <setInputCloud (), setIndices ()> More...

## Protected Member Functions

virtual std::string | getClassName () const
| Class getName method. More...

## Protected Attributes

CloudDevice | input_
| the input cloud on the GPU More...
PointCloudHostPtr | host_cloud_
| the original cloud the Host More...
GPUTreePtr | tree_
| A pointer to the spatial search object. More...
double | cluster_tolerance_
| The spatial cluster tolerance as a measure in the L2 Euclidean space. More...
int | min_pts_per_cluster_
| The minimum number of points that a cluster needs to contain in order to be considered valid (default = 1). More...
int | max_pts_per_cluster_
| The maximum number of points that a cluster needs to contain in order to be considered valid (default = MAXINT). More...

## Detailed Description

### template<typename PointT>
class pcl::gpu::EuclideanLabeledClusterExtraction< PointT >

EuclideanLabeledClusterExtraction represents a segmentation class for cluster extraction in an Euclidean sense, depending on pcl::gpu::octree

Author
  Koen Buys, Radu Bogdan Rusu

Definition at line 67 of file gpu_extract_labeled_clusters.h.

## Member Typedef Documentation

## CloudDevice

template<typename PointT >

typedef pcl::gpu::Octree::PointCloud pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::CloudDevice

Definition at line 81 of file gpu_extract_labeled_clusters.h.

## GPUTree

template<typename PointT >

typedef pcl::gpu::Octree pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::GPUTree

Definition at line 78 of file gpu_extract_labeled_clusters.h.

## GPUTreePtr

template<typename PointT >

typedef pcl::gpu::Octree::Ptr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::GPUTreePtr

Definition at line 79 of file gpu_extract_labeled_clusters.h.

## PointCloudHost

template<typename PointT >

typedef pcl::PointCloud<PointT> pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::PointCloudHost

Definition at line 71 of file gpu_extract_labeled_clusters.h.

## PointCloudHostConstPtr

template<typename PointT >

typedef PointCloudHost::ConstPtr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::PointCloudHostConstPtr

Definition at line 73 of file gpu_extract_labeled_clusters.h.

## PointCloudHostPtr

template<typename PointT >

typedef PointCloudHost::Ptr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::PointCloudHostPtr

Definition at line 72 of file gpu_extract_labeled_clusters.h.

## PointIndicesConstPtr

template<typename PointT >

typedef PointIndices::ConstPtr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::PointIndicesConstPtr

Definition at line 76 of file gpu_extract_labeled_clusters.h.

## PointIndicesPtr

template<typename PointT >

typedef PointIndices::Ptr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::PointIndicesPtr

Definition at line 75 of file gpu_extract_labeled_clusters.h.

## PointType

template<typename PointT >

typedef pcl::PointXYZ pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::PointType

Definition at line 70 of file gpu_extract_labeled_clusters.h.

## Constructor & Destructor Documentation

## EuclideanLabeledClusterExtraction()

template<typename PointT >

pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::EuclideanLabeledClusterExtraction | ( |  | ) |

inline

Empty constructor.

Definition at line 85 of file gpu_extract_labeled_clusters.h.

## Member Function Documentation

## extract()

template<typename PointT >

void pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::extract | ( | std::vector< PointIndices > & | clusters | ) |

Cluster extraction in a PointCloud given by <setInputCloud (), setIndices ()>

Parameters

  clusters | the resultant point clusters

Definition at line 150 of file gpu_extract_labeled_clusters.hpp.

References pcl::gpu::compareLabeledPointClusters(), and pcl::extractLabeledEuclideanClusters().

Referenced by pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setHostCloud().

## getClassName()

template<typename PointT >

virtual std::string pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getClassName | ( |  | ) | const

inline protected virtual

Class getName method.

Definition at line 151 of file gpu_extract_labeled_clusters.h.

## getClusterTolerance()

template<typename PointT >

double pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getClusterTolerance | ( |  | ) |

inline

Get the spatial cluster tolerance as a measure in the L2 Euclidean space.

Definition at line 104 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::cluster_tolerance_.

## getMaxClusterSize()

template<typename PointT >

int pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getMaxClusterSize | ( |  | ) |

inline

Get the maximum number of points that a cluster needs to contain in order to be considered valid.

Definition at line 120 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::max_pts_per_cluster_.

## getMinClusterSize()

template<typename PointT >

int pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getMinClusterSize | ( |  | ) |

inline

Get the minimum number of points that a cluster needs to contain in order to be considered valid.

Definition at line 112 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::min_pts_per_cluster_.

## getSearchMethod()

template<typename PointT >

GPUTreePtr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getSearchMethod | ( |  | ) |

inline

Get a pointer to the search method used.

Definition at line 96 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::tree_.

## setClusterTolerance()

template<typename PointT >

void pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setClusterTolerance | ( | double | tolerance | ) |

inline

Set the spatial cluster tolerance as a measure in the L2 Euclidean space.

Parameters

  tolerance | the spatial cluster tolerance as a measure in the L2 Euclidean space

Definition at line 101 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::cluster_tolerance_.

## setHostCloud()

template<typename PointT >

void pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setHostCloud | ( | PointCloudHostPtr | host_cloud | ) |

inline

Definition at line 124 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::extract(), and pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::host_cloud_.

## setInput()

template<typename PointT >

void pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setInput | ( | CloudDevice | input | ) |

inline

Definition at line 122 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::input_.

## setMaxClusterSize()

template<typename PointT >

void pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setMaxClusterSize | ( | int | max_cluster_size | ) |

inline

Set the maximum number of points that a cluster needs to contain in order to be considered valid.

Parameters

  max_cluster_size | the maximum cluster size

Definition at line 117 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::max_pts_per_cluster_.

## setMinClusterSize()

template<typename PointT >

void pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setMinClusterSize | ( | int | min_cluster_size | ) |

inline

Set the minimum number of points that a cluster needs to contain in order to be considered valid.

Parameters

  min_cluster_size | the minimum cluster size

Definition at line 109 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::min_pts_per_cluster_.

## setSearchMethod()

template<typename PointT >

void pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setSearchMethod | ( | const GPUTreePtr & | tree | ) |

inline

Provide a pointer to the search object.

Parameters

  tree | a pointer to the spatial search object.

Definition at line 91 of file gpu_extract_labeled_clusters.h.

References pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::tree_.

## Member Data Documentation

## cluster_tolerance_

template<typename PointT >

double pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::cluster_tolerance_

protected

The spatial cluster tolerance as a measure in the L2 Euclidean space.

Definition at line 142 of file gpu_extract_labeled_clusters.h.

Referenced by pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getClusterTolerance(), and pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setClusterTolerance().

## host_cloud_

template<typename PointT >

PointCloudHostPtr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::host_cloud_

protected

the original cloud the Host

Definition at line 136 of file gpu_extract_labeled_clusters.h.

Referenced by pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setHostCloud().

## input_

template<typename PointT >

CloudDevice pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::input_

protected

the input cloud on the GPU

Definition at line 133 of file gpu_extract_labeled_clusters.h.

Referenced by pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setInput().

## max_pts_per_cluster_

template<typename PointT >

int pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::max_pts_per_cluster_

protected

The maximum number of points that a cluster needs to contain in order to be considered valid (default = MAXINT).

Definition at line 148 of file gpu_extract_labeled_clusters.h.

Referenced by pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getMaxClusterSize(), and pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setMaxClusterSize().

## min_pts_per_cluster_

template<typename PointT >

int pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::min_pts_per_cluster_

protected

The minimum number of points that a cluster needs to contain in order to be considered valid (default = 1).

Definition at line 145 of file gpu_extract_labeled_clusters.h.

Referenced by pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getMinClusterSize(), and pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setMinClusterSize().

## tree_

template<typename PointT >

GPUTreePtr pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::tree_

protected

A pointer to the spatial search object.

Definition at line 139 of file gpu_extract_labeled_clusters.h.

Referenced by pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::getSearchMethod(), and pcl::gpu::EuclideanLabeledClusterExtraction< PointT >::setSearchMethod().

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/gpu/segmentation/include/pcl/gpu/segmentation/gpu_extract_labeled_clusters.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/gpu/segmentation/include/pcl/gpu/segmentation/impl/gpu_extract_labeled_clusters.hpp